import es, cfglib, playerlib
import weaponlib

info = es.AddonInfo()
info['name']        = "DM Commons"
info['version']     = "1.0.2"
info['author']      = "DanielB" 
info['url']         = "http://forums.eventscripts.com/viewtopic.php?t=34141" 
info['description'] = "Common DM functions such as armor, grenades and ammo" 

dm = es.import_addon('dm')

class Settings(object):
    config = cfglib.AddonCFG(dm.addondir + '/dm/addons/commons/settings.cfg')
    
    _armor  = config.cvar('dm_commons_armor', '100', 'Amount of armor to give players on spawn (0 to disable)'), int
    _givehe = config.cvar('dm_commons_hegrenade', '1', 'Give hegrenade on spawn? (0=off,1=on)'), int
    _givesg = config.cvar('dm_commons_smokegrenade', '1', 'Give smokegrenade on spawn? (0=off,1=on)'), int
    _givefb = config.cvar('dm_commons_flashbang', '0', 'Give flashbang on spawn? (0=off,1=give one,2=give two)'), int
    _ammo   = config.cvar('dm_commons_ammo', '1', 'Give players an unlimited amount of reloads? (0=off,1=on)'), int
    _nvgs   = config.cvar('dm_commons_nightvision', '1', 'Give players nightvision? (0=off,1=on)'), int
    
    config.execute()
    
    def __init__(self):
        self.config.write()
        
    def __getattr__(self, name):
        if hasattr(Settings, name):
            return super(Settings, self).__getattribute__(name)
           
        elif hasattr(Settings, '_'+name):
            val, func = super(Settings, self).__getattribute__('_'+name)
            return func(val)
           
        raise AttributeError, 'No such attribute "%s"'%name
        
settings = Settings()

noisy_incd = False

def load():
    global noisy_incd
    if settings.ammo:
        es.doblock('corelib/noisy_on')
        noisy_incd = True
        
    dm.msg('Loaded Addon - DM Commons')
    
def unload():
    if noisy_incd:
        es.doblock('corelib/noisy_off')
    dm.msg('Unloaded Addon - DM Commons')
    
def give(userid, item):
    # This is delayed to work with the guns menus
    es.delayed(0.1, 'es_xgive %s %s'%(userid, item))
    
def give_ammo(userid):
    player = playerlib.getPlayer(userid)
    primary = player.getPrimary()
    secondary = player.getSecondary()
    for weapon in [primary, secondary]:
        if weapon:
            #player.setAmmo(weapon, 100)
            max_ammo = weaponlib.getWeapon(weapon).maxammo
            player.setAmmo(weapon, max_ammo)
    
def weapon_reload(event_var):
    give_ammo(event_var['userid'])
        
def weapon_fire_on_empty(event_var):
    give_ammo(event_var['userid'])
    
def dm_player_loadout(event_var):
    if int(event_var['prestripped']):
        player_spawn(event_var)
    
def player_spawn(event_var):
    userid = event_var['userid']
    
    if es.getplayerteam(userid) in (2,3):
        armor = settings.armor
        givefb = settings.givefb
        player = playerlib.getPlayer(userid)
    
        if armor:
            player.armor = armor
        
        if settings.givehe:
            give(userid, 'weapon_hegrenade')
        if settings.givesg:
            give(userid, 'weapon_smokegrenade')
        
        if givefb > 0:
            give(userid, 'weapon_flashbang')
        if givefb > 1:
            give(userid, 'weapon_flashbang')
            
        if settings.nvgs:
            player.nightvision = 1
    



    
