import es, time, usermsg, cfglib

dm = es.import_addon('dm')
delay = dm.delay


class Settings(object):
    config = cfglib.AddonCFG(dm.addondir + '/dm/addons/respawntypes/wave2/settings.cfg')
    _respawntime   = config.cvar('dm_wave2_respawntime', 7.0, 'Respawn interval [Time after death/time between waves]'), float
    
    config.execute()
    
    def __init__(self):
        self.config.write()
        
    def __getattr__(self, name):
        if hasattr(Settings, name):
            return super(Settings, self).__getattribute__(name)
           
        elif hasattr(Settings, '_'+name):
            val, func = super(Settings, self).__getattribute__('_'+name)
            return func(val)
           
        raise AttributeError, 'No such attribute "%s"'%name
        
settings = Settings()

class Wave2:
    def __init__(self):
        self.reset(False)
    def reset(self, restart=True):
        self.t = False
        self.ct = False
        
        delay.cancel('dm_wave2_t')
        delay.cancel('dm_wave2_ct')
        delay.cancel('dm_wave2')
        
        if restart:
            delay.delayed(1, 'dm_wave2', self.hudloop)
        
    
    def hudloop(self):
        
        thetime = time.time()
        if self.t:
            t = '%ss'%int(self.t - thetime)
        else:
            t = 'All Alive'
        
        if self.ct:
            ct = '%ss'%int(self.ct - thetime)
        else:
            ct = 'All Alive'
            
        text = 'Wave Respawn\nTerrorists : %s\nCounter Terrorists : %s'%(t, ct)
        usermsg.hudhint('#all', text)
            
        delay.delayed(1, 'dm_wave2', self.hudloop)
    
    def go(self, team):
        for userid in es.getUseridList():
            if es.getplayerteam(userid) == team and not dm.isAlive(userid):
                dm.respawn(userid)
        
        if team == 2:
            self.t = False
        if team == 3:
            self.ct = False
        
        delay.cancel('dm_wave2')
        self.hudloop()
                
    def check(self, userid):
        team = es.getplayerteam(userid)
        if team == 2:
            if not self.t:
                d = settings.respawntime
                self.t = time.time() + d
                delay.delayed(d, 'dm_wave2_t', self.go, (2,))
        elif team == 3:
            if not self.ct:
                d = settings.respawntime
                self.ct = time.time() + d
                delay.delayed(d, 'dm_wave2_ct', self.go, (3,))
                
respawn_wave2 = Wave2()


def load():
    respawn_wave2.reset(True)

def unload():
    respawn_wave2.reset(False)
    
def player_death(ev):
    respawn_wave2.check(ev['userid'])
    
def round_start(ev):
    respawn_wave2.reset(True)
    
def round_end(ev):
    respawn_wave2.reset(False)